<template>
    <v-row justify="center">
        <v-col cols="6">
            <v-card>
                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                    <v-container class="px-8">
                        <v-row>
                            <v-col>
                                <div class="title text--primary">
                                    {{ $t("change_password") }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="field-label">
                                    {{ $t("old_password") }}
                                </div>
                                <ValidationProvider v-slot="{ errors }" name="old_password" rules="required">
                                    <v-text-field
                                        v-model="old_password"
                                        :placeholder="$t('old_password')"
                                        :error-messages="errors"
                                        hide-details="auto"
                                        prepend-inner-icon="mdi-lock-outline"
                                        type="password"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col>
                                <div class="field-label">{{ $t("new_password") }}</div>
                                <ValidationProvider v-slot="{ errors }" name="password" rules="required|min:8">
                                    <v-text-field
                                        v-model="password"
                                        :placeholder="$t('new_password')"
                                        :error-messages="errors"
                                        hide-details="auto"
                                        prepend-inner-icon="mdi-lock"
                                        type="password"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col>
                                <div class="field-label">
                                    {{ $t("password_confirmation") }}
                                </div>
                                <ValidationProvider v-slot="{ errors }" name="password_confirmation" rules="required|password:@password">
                                    <v-text-field
                                        v-model="password_confirmation"
                                        :placeholder="$t('password_confirmation')"
                                        :error-messages="errors"
                                        hide-details="auto"
                                        prepend-inner-icon="mdi-lock"
                                        type="password"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col class="text-center">
                                <v-btn class="text--white mx-2" color="primary" @click="save" :loading="submit" large>
                                    <v-icon>mdi-content-save</v-icon>
                                    {{ $t('save') }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </ValidationObserver>
            </v-card>
        </v-col>

        <v-snackbar
            v-model="snackbar.show"
            :color="snackbar.color"
            :timeout="snackbar.timeout"
            absolute
        >
            {{ snackbar.message }}

            <template v-slot:action="{ attrs }">
                <v-btn
                    icon
                    color="white"
                    v-bind="attrs"
                    @click="snackbar.show = false"
                >
                    <v-icon>close</v-icon>
                </v-btn>
            </template>
        </v-snackbar>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from "vee-validate";

export default {
    name: "ChangePasswordForm",

    components: {
        ValidationObserver,
        ValidationProvider
    },

    data: () => ({
        old_password: '',
        password: '',
        password_confirmation: '',
        submit: false,
        snackbar: {
            show: false,
            message: null,
            color: null,
            timeout: 6000
        }
    }),

    methods: {

        clear() {
            this.old_password = '';
            this.password = '';
            this.password_confirmation = '';
        },

        save() {
            this.submit = true;
            this.$refs.observer.validate()
                .then(valid => {
                    if(valid) {
                        axios
                            .post("/api/user/password", {
                                old_password: this.old_password,
                                password: this.password,
                                password_confirmation: this.password_confirmation
                            })
                            .then(() => {
                                this.submit = false;
                                this.snackbar.show = true;
                                this.snackbar.color = 'success';
                                this.snackbar.message = this.$t('change_pass_success');
                                this.$refs.observer.reset();
                                this.clear();
                            })
                            .catch(({ response }) => {
                                this.$refs.observer.setErrors(response.data.errors);
                                this.submit = false;
                            });
                }
                else {

                    this.submit = false;
                }
            });
        }
    }
};
</script>
